/*
 * Copyright (c) 2005-, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

//LhaForgep

//fobOp֐ѕ֗Ȋ֐Q
#pragma once
//#pragma warning(disable:4786)

#if defined(_DEBUG) || defined(DEBUG)

void TraceLastError();

#else
// ReleasêƂ
#define TraceLastError()

#endif	//_DEBUG

//=============================================
// ʕ֗֐
//=============================================

//G[bZ[W\
int ErrorMessage(LPCTSTR);
//bZ[WLvV擾
LPCTSTR UtilGetMessageCaption();
void UtilGetLastErrorMessage(CString &strMsg);

#define BOOL2bool(x)	(FALSE!=x)

//z̒Ɏw肳ꂽL΂̈ʒuԂ;Ȃ-1Ԃ
int UtilCheckNumberArray(const int *lpcArray,int size,int c);

enum UTIL_CODEPAGE;

//X|Xt@Cǂݎ
bool UtilReadFromResponceFile(LPCTSTR lpszRespFile,UTIL_CODEPAGE,std::list<CString> &FileList);

//INIɐ𕶎Ƃď
BOOL UtilWritePrivateProfileInt(LPCTSTR lpAppName,LPCTSTR lpKeyName,LONG nData,LPCTSTR lpFileName);

//INIɎw肳ꂽZNVȂtrueԂ
bool UtilCheckINISectionExists(LPCTSTR lpAppName,LPCTSTR lpFileName);

//͂
bool UtilInputText(LPCTSTR lpszMessage,CString &strInput);

//^ꂽt@C}`{[ɂƌȂȂ猟쐬AtrueԂ
bool UtilIsMultiVolume(LPCTSTR lpszPath,CString &r_strFindParam);

//W̐ݒt@C̃pX擾
void UtilGetDefaultFilePath(CString &strPath,LPCTSTR lpszDir,LPCTSTR lpszFile,bool &bUserCommon);

//t@Cw肵p^[ɓĂ͂܂true
bool UtilExtMatchSpec(LPCTSTR lpszPath,LPCTSTR lpPattern);

//t@Cw肵2̏[]邩ǂ;ۂD;bDenyOnly=trueȂADenỹ`FbN̂ݍs
bool UtilPathAcceptSpec(LPCTSTR,LPCTSTR lpDeny,LPCTSTR lpAccept,bool bDenyOnly);

//IɃbZ[W[v
bool UtilDoMessageLoop();
VOID CALLBACK UtilMessageLoopTimerProc(HWND,UINT,UINT,DWORD);

//w肳ꂽmapL[Ă邩ǂ
template <typename mapclass,typename keyclass>
bool has_key(const mapclass &theMap,keyclass theKey){
	return theMap.find(theKey)!=theMap.end();
}

//w肳ꂽlz񒆂ɂ΂̃CfbNXT;-1
template <typename arrayclass,typename valueclass>
int index_of(const arrayclass &theArray,valueclass theValue){
	for(unsigned int i=0;i<theArray.size();++i){
		if(theArray[i]==theValue){
			return (signed)i;
		}
	}
	return -1;
}
//Rei̗vf폜
template <typename arrayclass,typename valueclass>
void remove_item(arrayclass &theArray,const valueclass &theValue){
	theArray.erase(std::remove(theArray.begin(), theArray.end(), theValue), theArray.end());
}
